macroScript superLag
	category:"Comet Cartoons"
	toolTip:"superLag: Does nice lag/Overlapping Action stuff automatically"
	Icon:#("CometCartoons",10)
(
--
-- CometCartoons-superLag.mcr - Michael B. Comet - comet@comet-cartoons.com
-- 											  http://www.comet-cartoons.com/
--		Copyright 2002,2003 Michael B. Comet  All Rights Reserved.
--
--
--	Known bugs: Does not work if "Set Key" mode is active.  Will work if "Auto Key"
--		if on, or if animate mode is totally off.
--
--
--

global sL_version = "1.04";
global sL_mainRoll;
global sL_bakeSimple = true;
global sL_bakeOnLag = true;

-- --------------------------------------------------------------------------

-- --------------------------------------------------------------------------
--								WORKING FUNCTIONS
-- --------------------------------------------------------------------------


-- -----------------------------------------------------------------------------------------------



/*
 * sL_addCtrlAttrs() - Adds control attrs to object
 */
fn sL_addCtrlAttrs obj =
(
    if (obj == undefined) then
		(
		format ("-- superLag INTERNAL ERROR: sL_addCtrlAttrs(), obj is undefined!\n");
		return();
		)

		-- Make sure user installed the AttributeHolder modifier.
    if (EmptyModifier != undefined) then
		(
			-- Add Attr Holder modifier
		addModifier obj (EmptyModifier());
		)

		--
		-- main attr def stuff
		--
    str = "superLagAttrs = attributes Custom_Attributes\n"+
		"(\n"+
	    "parameters main rollout:superLagAttrsRO\n"+
		"	(\n"+
		"	active type:#boolean default:false ui:activeCB"+
		"	strX type:#float default:100.0 ui:strXSpin\n"+
		"	strY type:#float default:100.0 ui:strYSpin\n"+
		"	strZ type:#float default:100.0 ui:strZSpin\n"+
		"	speed type:#float default:24.0 ui:speedSpin;\n"+
		"	falloff type:#float default:48.0 ui:falloffSpin;\n"+
		"	pctT type:#float default:100.0 ui:pctTSpin;\n"+
		"	pctR type:#float default:100.0 ui:pctRSpin;\n";
	str += "	)\n"+
		"   \n"+
		"rollout superLagAttrsRO \"Super Lag Parameters\"\n"+
		"   (\n"+
		"   checkbox 'activeCB' \"Active\" checked:false offset:[45,0];\n"+
		"   spinner 'strXSpin' \"Strength X\" fieldWidth:60 type:#float range:[-1000,1000,100];\n"+
		"   spinner 'strYSpin' \"Strength Y\" fieldWidth:60 type:#float range:[-1000,1000,100];\n"+
		"   spinner 'strZSpin' \"Strength Z\" fieldWidth:60 type:#float range:[-1000,1000,100];\n"+
		"   spinner 'speedSpin' \"Bounce Frames\" fieldWidth:60 type:#float range:[1,1000,24];\n"+
		"   spinner 'falloffSpin' \"Falloff Frames\" fieldWidth:60 type:#float range:[1,100,48];\n"+
		"   spinner 'pctTSpin' \"Translation %\" fieldWidth:60 type:#float range:[-1000,1000,100];\n"+
		"   spinner 'pctRSpin' \"Rotation %\" fieldWidth:60 type:#float range:[-1000,1000,100];\n";
    str += "   )\n"+
		");\n"+
		"\n" ;
	execute str;

		--
		-- Add some custom def data like MAX does, so we can retrieve RANGE info later for things like my attrKey script.
		--
	str = "\n"+
		"pb0 = CAT_ParamBlock name:\"'active'\" type:\"boolean\" ui:\"activeCB\" default:\"0\";\n"+
		"pb1 = CAT_ParamBlock name:\"'strX'\" type:\"Float\" ui:\"strXSpin\" default:\"100.0\";\n"+
		"pb2 = CAT_ParamBlock name:\"'strY'\" type:\"Float\" ui:\"strYSpin\" default:\"100.0\";\n"+
		"pb3 = CAT_ParamBlock name:\"'strZ'\" type:\"Float\" ui:\"strZSpin\" default:\"100.0\";\n"+
		"pb4 = CAT_ParamBlock name:\"'speed'\" type:\"Float\" ui:\"speedSpin\" default:\"24.0\";\n"+
		"pb5 = CAT_ParamBlock name:\"'falloff'\" type:\"Float\" ui:\"falloffSpin\" default:\"48.0\";\n"+
		"pb6 = CAT_ParamBlock name:\"'pctT'\" type:\"Float\" ui:\"pctTSpin\" default:\"100.0\";\n"+
		"pb7 = CAT_ParamBlock name:\"'pctR'\" type:\"Float\" ui:\"pctRSpin\" default:\"100.0\";\n";

		str += "ui0 = CAT_UIItem ui:\"Checkbox\" name:\"'active'\" type:\"Boolean\" ;\n"+
			   "ui1 = CAT_UIItem ui:\"Spinner\" name:\"'strX'\" type:\"Float\" range:\"[-1000,1000,100]\";\n"+
			   "ui2 = CAT_UIItem ui:\"Spinner\" name:\"'strY'\" type:\"Float\" range:\"[-1000,1000,100]\";\n"+
			   "ui3 = CAT_UIItem ui:\"Spinner\" name:\"'strZ'\" type:\"Float\" range:\"[-1000,1000,100]\";\n"+
			   "ui4 = CAT_UIItem ui:\"Spinner\" name:\"'speed'\" type:\"Float\" range:\"[1,1000,24]\";\n"+
			   "ui5 = CAT_UIItem ui:\"Spinner\" name:\"'falloff'\" type:\"Float\" range:\"[1,100,10]\";\n"+
			   "ui6 = CAT_UIItem ui:\"Spinner\" name:\"'pctT'\" type:\"Float\" range:\"[-1000,1000,100]\";\n"+
			   "ui7 = CAT_UIItem ui:\"Spinner\" name:\"'pctR'\" type:\"Float\" range:\"[-1000,1000,100]\";\n";
		str += "arr1 = #(pb0, pb1, pb2, pb3, pb4, pb5, pb6, pb7 );\n"+
			   "arr2 = #(ui0, ui1, ui2, ui3, ui4, ui5, ui6, ui7 );\n";
		str += "theArr = #(arr1, arr2)\n"+
		"\n"+
		"custAttributes.setDefData superLagAttrs theArr;\n";
	execute str;

    if (EmptyModifier != undefined) then
		str = "custAttributes.add $"+(obj.name)+".Attribute_Holder superLagAttrs;";
	else
		str = "custAttributes.add $"+(obj.name)+" superLagAttrs;";
	execute str;
		--
		-- Now add a default controller too
		--
    if (EmptyModifier != undefined) then
		(
		str = "";
		str += "$"+(obj.name)+".Attribute_Holder.active.controller = Boolean_Float();\n";
		str += "$"+(obj.name)+".Attribute_Holder.strX.controller = Bezier_Float();\n";
		str += "$"+(obj.name)+".Attribute_Holder.strY.controller = Bezier_Float();\n";
		str += "$"+(obj.name)+".Attribute_Holder.strZ.controller = Bezier_Float();\n";
		str += "$"+(obj.name)+".Attribute_Holder.speed.controller = Bezier_Float();\n";
		str += "$"+(obj.name)+".Attribute_Holder.falloff.controller = Bezier_Float();\n";
		str += "$"+(obj.name)+".Attribute_Holder.pctT.controller = Bezier_Float();\n";
		str += "$"+(obj.name)+".Attribute_Holder.pctR.controller = Bezier_Float();\n";
		)
	else
		(
		str = "";
		str += "$"+(obj.name)+".active.controller = Boolean_Float();\n";
		str += "$"+(obj.name)+".strX.controller = Bezier_Float();\n";
		str += "$"+(obj.name)+".strY.controller = Bezier_Float();\n";
		str += "$"+(obj.name)+".strZ.controller = Bezier_Float();\n";
		str += "$"+(obj.name)+".speed.controller = Bezier_Float();\n";
		str += "$"+(obj.name)+".falloff.controller = Bezier_Float();\n";
		str += "$"+(obj.name)+".pctT.controller = Bezier_Float();\n";
		str += "$"+(obj.name)+".pctR.controller = Bezier_Float();\n";
		)
	execute str;

)

-- --------------------------------------------------------------------------


/*
 * sL_addSlaveAttrs() - Adds slaves attrs to object
 */
fn sL_addSlaveAttrs obj =
(
    if (obj == undefined) then
		(
		format ("-- superLag INTERNAL ERROR: sL_addCtrlAttrs(), obj is undefined!\n");
		return();
		)


		--
		-- main attr def stuff
		--
    str = "superLagSlaveAttrs = attributes Custom_Attributes\n"+
		"(\n"+
	    "parameters main rollout:superLagSlaveAttrsRO\n"+
		"	(\n"+
		"	yUp type:#boolean default:false ui:yUpCBox;\n"+
		"	forceT1 type:#float default:0.0 ui:forceT1Spin;\n"+
		"	forceT2 type:#float default:0.0 ui:forceT2Spin;\n"+
		"	forceT3 type:#float default:0.0 ui:forceT3Spin;\n"+
		"	forceR1 type:#float default:0.0 ui:forceR1Spin;\n"+
		"	forceR2 type:#float default:0.0 ui:forceR2Spin;\n"+
		"	forceR3 type:#float default:0.0 ui:forceR3Spin;\n";
	str += "	)\n"+
		"   \n"+
		"rollout superLagSlaveAttrsRO \"Super Lag Parameters\"\n"+
		"   (\n"+
		"   checkbox 'yUpCBox' \"Y Axis is Up (Not Z)\" checked:false offset:[30,0];\n"+
		"   spinner 'forceT1Spin' \"force TX\" fieldWidth:60 type:#float range:[-9999,9999,0];\n"+
		"   spinner 'forceT2Spin' \"force TY\" fieldWidth:60 type:#float range:[-9999,9999,0];\n"+
		"   spinner 'forceT3Spin' \"force TZ\" fieldWidth:60 type:#float range:[-9999,9999,0];\n"+
		"   spinner 'forceR1Spin' \"force RX\" fieldWidth:60 type:#float range:[-9999,9999,0];\n"+
		"   spinner 'forceR2Spin' \"force RY\" fieldWidth:60 type:#float range:[-9999,9999,0];\n"+
		"   spinner 'forceR3Spin' \"force RZ\" fieldWidth:60 type:#float range:[-9999,9999,0];\n";
    str += "   )\n"+
		");\n"+
		"\n" ;
	execute str;

		--
		-- Add some custom def data like MAX does, so we can retrieve RANGE info later for things like my attrKey script.
		--
	str = "\n"+
		"pb1 = CAT_ParamBlock name:\"'yUp'\" type:\"Boolean\" ui:\"yUpCBox\" default:\"false\";\n"+
		"pb2 = CAT_ParamBlock name:\"'forceT1'\" type:\"Float\" ui:\"forceT1Spin\" default:\"0.0\";\n"+
		"pb3 = CAT_ParamBlock name:\"'forceT2'\" type:\"Float\" ui:\"forceT2Spin\" default:\"0.0\";\n"+
		"pb4 = CAT_ParamBlock name:\"'forceT3'\" type:\"Float\" ui:\"forceT3Spin\" default:\"0.0\";\n"+
		"pb5 = CAT_ParamBlock name:\"'forceR1'\" type:\"Float\" ui:\"forceR1Spin\" default:\"0.0\";\n"+
		"pb6 = CAT_ParamBlock name:\"'forceR2'\" type:\"Float\" ui:\"forceR2Spin\" default:\"0.0\";\n"+
		"pb7 = CAT_ParamBlock name:\"'forceR3'\" type:\"Float\" ui:\"forceR3Spin\" default:\"0.0\";\n";

		str +=
			   "ui1 = CAT_UIItem ui:\"Checkbox\" name:\"'yUp'\" type:\"Boolean\" ;\n"+
			   "ui2 = CAT_UIItem ui:\"Spinner\" name:\"'forceT1'\" type:\"Float\" range:\"[-9999,9999,0]\";\n"+
			   "ui3 = CAT_UIItem ui:\"Spinner\" name:\"'forceT2'\" type:\"Float\" range:\"[-9999,9999,0]\";\n"+
			   "ui4 = CAT_UIItem ui:\"Spinner\" name:\"'forceT3'\" type:\"Float\" range:\"[-9999,9999,0]\";\n"+
			   "ui5 = CAT_UIItem ui:\"Spinner\" name:\"'forceR1'\" type:\"Float\" range:\"[-9999,9999,0]\";\n"+
			   "ui6 = CAT_UIItem ui:\"Spinner\" name:\"'forceR2'\" type:\"Float\" range:\"[-9999,9999,0]\";\n"+
			   "ui7 = CAT_UIItem ui:\"Spinner\" name:\"'forceR3'\" type:\"Float\" range:\"[-9999,9999,0]\";\n";
		str += "arr1 = #(pb1, pb2, pb3, pb4, pb5, pb6, pb7);\n"+
			   "arr2 = #(ui1, ui2, ui3, ui4, ui5, ui6, ui7);\n";
		str += "theArr = #(arr1, arr2)\n"+
		"\n"+
		"custAttributes.setDefData superLagSlaveAttrs theArr;\n";
	execute str;

	str = "custAttributes.add $"+(obj.name)+" superLagSlaveAttrs;";
	execute str;
		--
		-- Now add a default controller too
		--
	str = "";
	str += "$"+(obj.name)+".yUp.controller = Boolean_Float();\n";
	str += "$"+(obj.name)+".forceT1.controller = Bezier_Float();\n";
	str += "$"+(obj.name)+".forceT2.controller = Bezier_Float();\n";
	str += "$"+(obj.name)+".forceT3.controller = Bezier_Float();\n";
	str += "$"+(obj.name)+".forceR1.controller = Bezier_Float();\n";
	str += "$"+(obj.name)+".forceR2.controller = Bezier_Float();\n";
	str += "$"+(obj.name)+".forceR3.controller = Bezier_Float();\n";
	execute str;

)


-- --------------------------------------------------------------------------


/*
 * sL_addSIMPLECtrlAttrs() - Adds SIMPLE attrs to object
 */
fn sL_addSIMPLECtrlAttrs obj =
(
    if (obj == undefined) then
		(
		format ("-- superLag INTERNAL ERROR: sL_addSIMPLECtrlAttrs(), obj is undefined!\n");
		return();
		)

		-- Make sure user installed the AttributeHolder modifier.
    if (EmptyModifier != undefined) then
		(
			-- Add Attr Holder modifier
		addModifier obj (EmptyModifier());
		)

		--
		-- main attr def stuff
		--
    str = "superLagSIMPLEAttrs = attributes Custom_Attributes\n"+
		"(\n"+
	    "parameters main rollout:superLagSIMPLEAttrsRO\n"+
		"	(\n"+
		"	frameDelay type:#integer default:-2 ui:frameDelaySpin;\n";
	str += "	)\n"+
		"   \n"+
		"rollout superLagSIMPLEAttrsRO \"Super Lag SIMPLE Parameters\"\n"+
		"   (\n"+
		"   spinner 'frameDelaySpin' \"frameDelay\" fieldWidth:60 type:#integer range:[-1000,1000,-2];\n";
    str += "   )\n"+
		");\n"+
		"\n" ;
	execute str;

		--
		-- Add some custom def data like MAX does, so we can retrieve RANGE info later for things like my attrKey script.
		--
	str = "\n"+
		"pb1 = CAT_ParamBlock name:\"'frameDelay'\" type:\"Integer\" ui:\"frameDelaySpin\" default:\"-2\"; \n";
		str += "ui1 = CAT_UIItem ui:\"Spinner\" name:\"'frameDelay'\" type:\"Integer\" range:\"[-1000,1000,-2]\";\n";
		str += "arr1 = #(pb1 );\n"+
			   "arr2 = #(ui1 );\n";
		str += "theArr = #(arr1, arr2)\n"+
		"\n"+
		"custAttributes.setDefData superLagSIMPLEAttrs theArr;\n";
	execute str;

    if (EmptyModifier != undefined) then
		str = "custAttributes.add $"+(obj.name)+".Attribute_Holder superLagSIMPLEAttrs;";
	else
		str = "custAttributes.add $"+(obj.name)+" superLagSIMPLEAttrs;";
	execute str;
		--
		-- Now add a default controller too
		--
    if (EmptyModifier != undefined) then
		(
		str = "";
		str += "$"+(obj.name)+".Attribute_Holder.frameDelay.controller = Bezier_Float();\n";
		)
	else
		(
		str = "";
		str += "$"+(obj.name)+".frameDelay.controller = Bezier_Float();\n";
		)
	execute str;

)


-- --------------------------------------------------------------------------

/*
 * zeroOut() - Zero's out an objects PRS data by parenting another object with the suffix ZEROINT
 *		at the end.  This is a straight grab from my zeroOut macro script...except this takes
 *		ONE object to zero.
 */
fn sL_zeroOut obj =
(
	pt = Point pos:[0,0,0] isSelected:on centermarker:on axistripod:off cross:off Box:off constantscreensize:off drawontop:off size:20;
		-- Insert into hierarchy
	pt.parent = obj.parent;
		-- Now snap it to same values
	coordsys world
		(
		pt.scale = obj.scale;
		pt.rotation = obj.rotation;
		pt.position = obj.position;
		pt.wirecolor = (color 80 10 0);
		pt.name = (obj.name+"ZEROINT");
		)
		-- reparent object
	obj.parent = pt;

		-- Now also store this zero'd position as a Max 5 Skin Pose
	obj.skinPose.setSkinPose();

		-- and hide the zero
--	hide pt;

)


-- --------------------------------------------------------------------------

fn createCTRLShape =
(

	ln = line();
	splIdx = addNewSpline ln;
		addKnot ln splIdx #bezierCorner #curve [-7.72373e-007,17.6698,0] [-8.6661e-007,14.7249,-5.10084] [-4.20679e-007,14.7249,5.10084];
		addKnot ln splIdx #bezierCorner #curve [2.82708e-007,8.83492,15.3025] [0,11.7799,10.2017] [5.40166e-007,2.94497,15.3025];
		addKnot ln splIdx #bezierCorner #curve [1.05508e-006,-8.83492,15.3025] [7.97624e-007,-2.94497,15.3025] [9.60846e-007,-11.7799,10.2017];
		addKnot ln splIdx #bezierCorner #curve [7.72373e-007,-17.6698,-1.54475e-006] [8.66609e-007,-14.7249,5.10084] [4.20679e-007,-14.7249,-5.10085];
		addKnot ln splIdx #bezierCorner #curve [-2.82708e-007,-8.83492,-15.3025] [0,-11.7799,-10.2017] [-5.40166e-007,-2.94497,-15.3025];
		addKnot ln splIdx #bezierCorner #curve [-1.05508e-006,8.83492,-15.3025] [-7.97624e-007,2.94498,-15.3025] [-9.60846e-007,11.7799,-10.2017];
	close ln splIdx;
	updateShape ln;
	convertToSplineShape ln;
	ln.wireColor = (color 8 8 136);
	ln.name = uniqueName "lagCTRL";
	select ln;
	return ln;

)

-- --------------------------------------------------------------------------

/*
 * sL_getScale() - Based on an object, gets a scale multiplier for the
 *		created control and helper objects...
 */
fn sL_getScale obj =
(
	dist = 1.0;

	if (obj.children.count > 0) then
	    (
		dist = length ( obj.pos - obj.children[1].pos ) / 60.0 ;
		)
	else if (obj.parent != undefined) then
		(
	    dist = length ( obj.pos - obj.parent.pos ) / 60.0 ;
	    )

    return dist;
)

-- --------------------------------------------------------------------------

/*
 * sL_rigSuper() - Rigs the given object for superLag mode
 */
fn sL_rigSuper obj =
(
	scl = sL_getScale obj;	-- what size for objects?

		-- Make our lagSlave up...
	slave = Point pos:[0,0,0] isSelected:on centermarker:off axistripod:off cross:off Box:on constantscreensize:off drawontop:off size:(20.0*scl);
	slave.wirecolor = (color 80 10 0);
	slave.transform = obj.transform;		-- snap to same spot!
	slave.name = (obj.name+"LagAUTO");
	slave.rotation.controller = Euler_XYZ();
	slave.rotation.controller.axisOrder = 1;	-- XYZ order

		-- Add the attrs to the SLAVE object.
	sL_addSlaveAttrs slave;


		-- Make our lagCtrl up...
	ctrl = createCTRLShape();
	ctrl.transform = obj.transform;		-- snap to same spot!
	ctrl.name = (obj.name+"LagCTRL");
	ctrl.rotation.controller.axisOrder = 6;	-- ZYX order
	ctrl.scale = [scl, scl, scl];

		-- Add the attrs to the CTRL object.
	sL_addCtrlAttrs ctrl;

	-- Now insert into hierarchy.

	ctrl.parent = obj.parent;
	sL_zeroOut ctrl;
	slave.parent = ctrl;
	obj.parent = slave;

	-- SETUP EXPRESSION FOR LAG HERE
	--
	slave.rotation.controller = Rotation_Script();

	str = "";

	str += ("-- superLag - SUPER Lag Rig Script \n");
	str += ("dependsOn $'"+ctrl.name+"' $'"+slave.name+"'; \n");

	str += ("\n");
    str += ("-- Read user ctrl values\n");

    ah = "";
	if (EmptyModifier != undefined) then
		(
		ah = ".Attribute_Holder";
		)


	str += ("-- Make sure CA's have been loaded on file load... \n");
	str += ("myD = custAttributes.get $'"+ctrl.name+"'"+ah+" 1; \n");
	str += ("if (myD != undefined) then \n");
	str += ("    ( \n");
	str += ("    \n");
    str += ("    -- Read user ctrl values\n");
	str += ("    active = $'"+ctrl.name+"'"+ah+".active; \n");
	str += ("    if (active) then \n");
	str += ("        ( \n");
	str += ("        str = #(0.0,0.0,0.0);\n");
	str += ("        str[1] = $'"+ctrl.name+"'"+ah+".strX / 100.0; \n");
	str += ("        str[2] = $'"+ctrl.name+"'"+ah+".strY / 100.0; \n");
	str += ("        str[3] = $'"+ctrl.name+"'"+ah+".strZ / 100.0; \n");
	str += ("        speed = $'"+ctrl.name+"'"+ah+".speed; \n");
	str += ("        falloff = $'"+ctrl.name+"'"+ah+".falloff; \n");
	str += ("        pctT = $'"+ctrl.name+"'"+ah+".pctT / 100.0; \n");
	str += ("        pctR = $'"+ctrl.name+"'"+ah+".pctR / 100.0; \n");
	str += ("        \n");
	str += ("        -- Figure pct falloff stuff\n");
	str += ("        fPct = 1.0; \n");
	str += ("        pctFall = (1.0 / falloff); \n");
	str += ("        \n");
	str += ("        -- Now figure force at current time based on pre-baked data\n");
	str += ("        forceT = #(0,0,0);\n");
	str += ("        forceR = #(0,0,0);\n");
	str += ("        t = currentTime;\n");
	str += ("        for t in currentTime to (currentTime - falloff) by (-1) do \n");
	str += ("            (\n");
	str += ("            at time t\n");
	str += ("                (\n");
	str += ("                forceT[1] += fPct * ($'"+slave.name+"'.forceT1); \n");
	str += ("                forceT[2] += fPct * ($'"+slave.name+"'.forceT2); \n");
	str += ("                forceT[3] += fPct * ($'"+slave.name+"'.forceT3); \n");
	str += ("                forceR[1] += fPct * ($'"+slave.name+"'.forceR1); \n");
	str += ("                forceR[2] += fPct * ($'"+slave.name+"'.forceR2); \n");
	str += ("                forceR[3] += fPct * ($'"+slave.name+"'.forceR3); \n");
	str += ("                )\n");
	str += ("            fPct -= pctFall;  -- now lower pct for prev frame\n");
	str += ("            )\n");
	str += ("        \n");
	str += ("        -- Now we can do basic cos stuff to get rotation\n");
	str += ("        cosVal = (cos( currentTime * 360.0 / speed )) ; -- do this here, faster than doing it twice \n");
	str += ("        for i in 1 to 3 do\n");
	str += ("            (\n");
	str += ("            forceT[i] = pctT * (forceT[i] * str[i] * cosVal ); \n");
	str += ("            forceR[i] = pctR * (forceR[i] * str[i] * cosVal ); \n");
	str += ("            )\n");
	str += ("        \n");
	str += ("        (eulerangles (forceT[1]+forceR[1]) (forceT[2]+forceR[2]) (forceT[3]+forceR[3])  );\n");
	str += ("        ) -- end of is active \n");
	str += ("    else \n");
	str += ("        ( \n");
	str += ("        (eulerangles 0 0 0) ;  \n");
	str += ("        ) -- end of is not active \n");
	str += ("    ) -- end of myD CA's defined \n");
	str += ("else \n");
	str += ("    ( \n");
	str += ("    (eulerangles 0 0 0) ;  \n");
	str += ("    ) -- end of CA's not defined \n");
	str += ("-- End of SUPER Lag script. \n");

	slave.rotation.controller.script = str;
	setTimeRange slave.rotation.controller -1000 10000;		-- make it work on nice long time range.



	select ctrl;

)

-- --------------------------------------------------------------------------


/*
 * sL_rigSimple() - Creates a simple lag rotation script on the objects
 */
fn sL_rigSimple obj delay =
(

	scl = sL_getScale obj;	-- what size for objects?

		-- Make our lagSlave up...
	slave = Point pos:[0,0,0] isSelected:on centermarker:off axistripod:off cross:off Box:on constantscreensize:off drawontop:off size:(20.0 * scl);
	slave.wirecolor = (color 80 10 0);
	slave.transform = obj.transform;		-- snap to same spot!
	slave.name = (obj.name+"LagAUTO");
	slave.rotation.controller = Euler_XYZ();
	slave.rotation.controller.axisOrder = 1;	-- XYZ order

		-- Make our lagCtrl up...
	ctrl = createCTRLShape();
	ctrl.transform = obj.transform;		-- snap to same spot!
	ctrl.name = (obj.name+"LagCTRL");
	ctrl.rotation.controller.axisOrder = 6;	-- ZYX order
	ctrl.scale = [scl, scl, scl];
	ctrl.wireColor = (color 10 140 10);

		-- Add attrs
	sL_addSIMPLECtrlAttrs ctrl;

		-- Now insert into hierarchy.
	ctrl.parent = obj.parent;
	sL_zeroOut ctrl;
	slave.parent = ctrl;
	obj.parent = slave;

	if (sL_bakeSimple == false) then
		(

		slave.rotation.controller = Rotation_Script();

		str = "";

		str += ("-- superLag - SIMPLE Lag Rig Script \n");
		str += ("dependsOn $'"+ctrl.name+"'.transform.controller; \n");

		if (EmptyModifier != undefined) then
			(
			ctrl.Attribute_Holder.frameDelay = delay;
			str += ("fD = $'"+ctrl.name+"'.Attribute_Holder.frameDelay; \n");
			)
		else
			(
			ctrl.frameDelay = delay;
			str += ("fD = $'"+ctrl.name+"'.frameDelay; \n");
			)

		str += ("\n");
		str += ("at time (currentTime + fD) \n");
		str += ("    ( \n");
		str += ("    rP = ( $'"+ctrl.name+"'.transform.rotation ); \n");
		str += ("    ) \n");
		str += ("rC = ( $'"+ctrl.name+"'.transform.rotation ); \n");
		str += ("rP - rC ; \n");

		str += ("-- End of SIMPLE Lag script. \n");

		slave.rotation.controller.script = str;
		setTimeRange slave.rotation.controller -1000 10000;		-- make it work on nice long time range.
		)
	else
		(
		slave.rotation.controller = Euler_XYZ();	-- Leave as regular
		)

    select ctrl;

)


-- --------------------------------------------------------------------------

/*
 * sL_rig() - Create a Lag rig for the selected objects.
 */
fn sL_rig mode =
(
    objs = getCurrentSelection();

	if (objs.count <= 0) then
		(
		format "-- ERROR: You must select the objects to rig first!\n";
		return();
		)

    max create mode;		-- now set to modify mode to show controls

		-- Init basic delay down chain....
    delay = -2;
    didOne = false;

		-- Rig each object...
    for obj in objs do
    	(
		if (mode == 1) then
			sL_rigSuper obj;
		else if (mode == 2) then
			sL_rigSimple obj delay;
		else if (mode == 0) then
			(
			if (didOne == false) then
				sL_rigSuper obj;
			else
				sL_rigSimple obj delay;
			didOne = true;
			)
		)

    max modify mode;		-- now set to modify mode to show controls

)

-- --------------------------------------------------------------------------

/*
 * sL_getSlaveName() - Given a control name, tries to get the name of the
 *		slave object.  ie:  fooLagCTRL -> fooLagAUTO.
 */
fn sL_getSlaveName ctrlName =
(
    sName = "";

		-- Take off last 4 letters of CTRL
		--
    cnt = ctrlName.count;
    for i in 1 to (cnt - 4) do
        sName += ctrlName[i];

    sName += "AUTO";	-- add new suffix

    return sName;		-- return new string

)



-- --------------------------------------------------------------------------

/*
 * sL_getCtrlName() - Given a slave name, tries to get the name of the
 *		slave object.  ie:  fooLagAUTO -> fooLagCTRL
 */
fn sL_getCtrlName slaveName =
(
    cName = "";

		-- Take off last 4 letters of CTRL
		--
    cnt = slaveName.count;
    for i in 1 to (cnt - 4) do
        cName += slaveName[i];

    cName += "CTRL";	-- add new suffix

    return cName;		-- return new string

)

-- --------------------------------------------------------------------------

/*
 * sL_doBakeSimpleLag() - Bakes simple lag.
 */
fn sL_doBakeSimpleLag ctrl =
(
    if (ctrl == undefined) then
        return();

    slaveName = sL_getSlaveName ctrl.name;
    slave = execute("$"+slaveName+";");

		-- Do ctrl to to ensure it is ok and not the auto slave selected.
    ctrlName = sL_getCtrlName ctrl.name;
    ctrl = execute("$"+ctrlName+";");

    if (slave == undefined) then
    	(
		format "-- ERROR: You must select a valid Lag CTRL object, with a similarly named LagSLAVE object parented underneath!\n";
		return();
		)

		-- Make sure we have right controller type in case it was rigged with
		-- a different mode.
		--
	if (classOf slave.rotation.controller != Euler_XYZ) then
		slave.rotation.controller = Euler_XYZ();


		-- Make sure we have a parent to even read from...if not, we'll just
		-- return now since there would be nothing to do.
		--
	if (ctrl == undefined) then
		return();

	st = animationRange.start;
	et = animationRange.end;
	ot = currentTime;

		-- Get some default values
		--
	delay = -2;

		-- First blow away all old keys on this time range
		--
	iv = (interval st et);
	selectKeys slave.rotation.x_rotation.controller iv;
	deleteKeys slave.rotation.x_rotation.controller #selection;
	selectKeys slave.rotation.y_rotation.controller iv;
	deleteKeys slave.rotation.y_rotation.controller #selection;
	selectKeys slave.rotation.z_rotation.controller iv;
	deleteKeys slave.rotation.z_rotation.controller #selection;
	selectKeys slave.position.controller iv;
	deleteKeys slave.position.controller #selection;

    disableSceneRedraw();   -- make it all faster!
	setWaitCursor();

	for t in st to et do
		(
		sliderTime = t;

			-- Get user parameters at this time
			--
		if (EmptyModifier != undefined) then
			(
			delay = (ctrl.Attribute_Holder.frameDelay);
			)
		else
			(
			delay = (ctrl.frameDelay);
			)


		coordsys world
			(
				-- Read parent rotation at prev time
			at time (t + delay)
				(
				pRot = ctrl.rotation;
				)
	

				-- Now set it now
			animate on
				(
				slave.rotation = pRot ;

				k = addNewKey slave.rotation.x_rotation.controller t;
--				k.inTangentType = k.outTangentType = #smooth;
				k = addNewKey slave.rotation.y_rotation.controller t;
--				k.inTangentType = k.outTangentType = #smooth;
				k = addNewKey slave.rotation.z_rotation.controller t;
--				k.inTangentType = k.outTangentType = #smooth;

				coordsys world
					(
					slave.position = ctrl.position;		-- make sure we are always centered still.
					)
				)

			)


		)

    

    sliderTime = ot;		-- go back to original time now.

    setArrowCursor();
    enableSceneRedraw();  

	select ctrl;

)

-- --------------------------------------------------------------------------

/*
 * round2 - rounds to 2 decimal places....not used tho
 */
fn round2 val =
(
    val = val * 100.0 ;
    val = floor val ;
    val = val / 100.0
    return val ; 
)

-- --------------------------------------------------------------------------


/*
 * sL_doLag() - Does the real lag work
 */
fn sL_doLag ctrl =
(
	if (ctrl == undefined) then
        return();

    slaveName = sL_getSlaveName ctrl.name;
    slave = execute("$"+slaveName+";");

		-- Do ctrl to to ensure it is ok and not the auto slave selected.
    ctrlName = sL_getCtrlName ctrl.name;
    ctrl = execute("$"+ctrlName+";");

    if (slave == undefined) then
    	(
		format "-- ERROR: You must select a valid Lag CTRL object, with a similarly named LagSLAVE object parented underneath!\n";
		return();
		)


		-- make it active for user.
	animate off
		(
		if (EmptyModifier != undefined) then
			ctrl.Attribute_Holder.active = true;
		else
			ctrl.active = true ;
		)


	st = animationRange.start;
	et = animationRange.end;
	ot = currentTime;


	tFactor = 1.0;		-- just so translations are closer to rots in amount

		-- Get some default values
		--
	yUp = false;


    forceT = #(0,0,0);
    forceR = #(0,0,0);
    lastFT = forceT ;
    lastFR = forceR;

	t1 = t2 = [0,0,0];
	r2 = [0,0,0];

		-- First blow away all old keys on this time range
		--
	iv = (interval st et);
	selectKeys slave.forceT1.controller iv;
	deleteKeys slave.forceT1.controller #selection;
	selectKeys slave.forceT2.controller iv;
	deleteKeys slave.forceT2.controller #selection;
	selectKeys slave.forceT3.controller iv;
	deleteKeys slave.forceT3.controller #selection;
	selectKeys slave.forceR1.controller iv;
	deleteKeys slave.forceR1.controller #selection;
	selectKeys slave.forceR2.controller iv;
	deleteKeys slave.forceR2.controller #selection;
	selectKeys slave.forceR3.controller iv;
	deleteKeys slave.forceR3.controller #selection;



		-- Init values for first frame out.
		--
	sliderTime = st;
    t = st;
	coordsys world
		(
		t1 = t2 = ctrl.pos;

		oldWR = quatToEuler ctrl.rotation order:1;
		r2 = ( eulerangles 0 0 0);
		)

		-- Make our helpers
		--
	mX = Point pos:ctrl.pos isSelected:off centermarker:on axistripod:on cross:off Box:off constantscreensize:off drawontop:off size:10;
	mY = Point pos:ctrl.pos isSelected:off centermarker:on axistripod:on cross:off Box:off constantscreensize:off drawontop:off size:10;
	mZ = Point pos:ctrl.pos isSelected:off centermarker:on axistripod:on cross:off Box:off constantscreensize:off drawontop:off size:10;
	mX.parent = ctrl;
	mY.parent = ctrl;
	mZ.parent = ctrl
	coordsys parent
		(
		mX.pos = [10,0,0];
		mY.pos = [0,10,0];
		mZ.pos = [0,0,10];
		)
	mX.name = ctrl.name+"measureX";
	mY.name = ctrl.name+"measureY";
	mZ.name = ctrl.name+"measureZ";


    disableSceneRedraw();   -- make it all faster!
	setWaitCursor();

		-- Start of main lag loop.
		--
	for t in st to et do
		(
		sliderTime = t;

			-- Get user parameters for this frame...
			--
		yUp = slave.yUp;


			-- Read new values
		coordsys world
			(
			t2 = ctrl.pos;
			-- r2 = ctrl.rotation as eulerangles;
			)


			-- Figure out our matrix for rotating back by previous world rotation
			--
		nR = oldWR;
		rotMatX = rotateXmatrix nR.x;
		rotMatY = rotateYmatrix nR.y;
		rotMatZ = rotateZmatrix nR.z;
		rotMat = rotMatX * rotMatY * rotMatZ;

			-- Read our measuring helpers....
			--
		coordsys world
			(
			dX = mX.pos - ctrl.pos;
			dY = mY.pos - ctrl.pos;
			dZ = mZ.pos - ctrl.pos;
			)
		dX = normalize dX;
		dY = normalize dY;
		dZ = normalize dZ;

			-- Now put them thru the matrix. That way we can read our rotation
			--	change in a more local way.  ie: in parent space basically.
			--
		dX  = dX * rotMat;
		dY  = dY * rotMat;
		dZ  = dZ * rotMat;


			-- Now manually figure out our rotation based on simple Trig.
			--	We don't do any 180 additions so that we don't have typical
			--	180 flop problem.  ie: when 0 -60 0 suddenly jumps to -180 -60 180
			--  Instead we'll get -80,-85, 90, 85, 80 etc....
			-- We leave our rotations as the base range we get.
			--	We also later will get the abs() value of it...so really we only
			--	handle rotations that are 90 degrees or less between each iteration.
			-- It's ok tho since most stuff will be within in that range for normal
			--	animation.
		rOff = #(0,0,0);		-- init
		if (dY.y != 0) then					-- x Rot
			r2.x = atan( dY.z / dY.y);
		if (dX.x != 0) then					-- y Rot
			r2.y = atan( dX.z / dX.x);
		if (dX.x != 0) then					-- z Rot
			r2.z = atan( dX.y / dX.x);


			-- So what is the difference in world rot?
			--
			--	Our measuring nulls were some offset from the previous reads rotation.
			--	This will now be in r2.  So therefore we now have our rotation delta.
			--
		forceR[1] = r2.x;
		forceR[2] = r2.y;
		forceR[3] = r2.z;


			-- Now lets look at Translation
			--
			--		What we want to do is even tho we have world translation, we
			--		need to look at it in a more relative way.  We NEED to use the
			--		world so we get data even if the ctrl itself isn't moving, but
			--		some other parent is... but then we need to know which way we are
			--		moving relative to the ctrl, so that we properly figure out
			--		what axis we are moving on.
			--
			--		For example we rotate a certain way if we move along the Y axis.
			--		However, if we were rotated 90 degrees and still moving the same
			--		way in the world, we'd probably be really looking at a different
			--		axis.
			--
			--		By doing a simple transformation matrix back to the original
			--		parent coordinate space, we can effectively rotate this world
			--		vector into the rotation relative to the ctrl, and then read
			--		the XYZ values as if they were the ctrl's.
			--
			--		We treat this entirely separately from rotation, do all the
			--		calculations and then set the data in PARENT space by adding
			--		to the already calculated new rotation from above.  Since
			--		all of thsi trans data is figured relative to parent space mode...
			--


			--	First get the difference between where we were and where we are...
			--
		tOff = t2 - t1;		-- keep this as a vector


			-- Now make our matrices up...
			--
		nR = quatToEuler ctrl.rotation order:1;		-- make sure we look at XYZ ordering here
		rotMatX = rotateXmatrix nR.x;
		rotMatY = rotateYmatrix nR.y;
		rotMatZ = rotateZmatrix nR.z;
		rotMat = rotMatX * rotMatY * rotMatZ;

			-- Now take our world translation change and put it thru the matrix
			--
		tOff = tOff * rotMat;


			-- Now we have real values
			-- 		We know that X looks down the forward axis for our rig
			--		So Y or Z must be up.  We can tell which way is up based
			--		on our custom attribute.
			--	Therefore we can decide how to rotate based on that info.
			--
			-- So we figure out the rot offsets based on Translate in Parent
			--	space now...
			--
		tRot = (point3 0 0 0);
		tRot.x = 0.0;
		tRot.y = (tOff.z * tFactor);
		tRot.z = (tOff.y * tFactor);
			-- Now based on which is "up", we decide how to rotate if
			--		we are moving -along- the forward X axis...
			--
		if (yUp == false) then
			tRot.y += (tOff.x * tFactor);
		else
			tRot.z += (tOff.x * tFactor);


			-- Set this into our force Trans array
		forceT[1] = tRot.x;
		forceT[2] = tRot.y;
		forceT[3] = tRot.z;


			-- Now clip all force with some "min" so we don't have little jiggles if force is really small
			--
		clip = 0.001 ;
		if (abs(forceR[1]) < clip) then
		    forceR[1] = 0.0 ;
		if (abs(forceR[2]) < clip) then 
		    forceR[2] = 0.0 ;
		if (abs(forceR[3]) < clip) then
		    forceR[3] = 0.0 ;
		if (abs(forceT[1]) < clip) then 
		    forceT[1] = 0.0 ;
		if (abs(forceT[2]) < clip) then 
		    forceT[2] = 0.0 ;
		if (abs(forceT[3]) < clip) then 
		    forceT[3] = 0.0 ;

			-- Also keep sign the same for smoother motion once a force has started
			--
		if (lastFR[1] != 0 ) then
		    (
		    if (lastFR[1] < 0 and forceR[1] > 0) then
		        forceR[1] *= -1 ;
		    else if (lastFR[1] > 0 and forceR[1] < 0) then
		        forceR[1] *= -1 ;
		    )
		if (lastFR[2] != 0 ) then
		    (
		    if (lastFR[2] < 0 and forceR[2] > 0) then
		        forceR[2] *= -1 ;
		    else if (lastFR[2] > 0 and forceR[2] < 0) then
		        forceR[2] *= -1 ;
		    )
		if (lastFR[3] != 0 ) then
		    (
		    if (lastFR[3] < 0 and forceR[3] > 0) then
		        forceR[3] *= -1 ;
		    else if (lastFR[3] > 0 and forceR[3] < 0) then
		        forceR[3] *= -1 ;
		    )

		if (lastFT[1] != 0 ) then
		    (
		    if (lastFT[1] < 0 and forceT[1] > 0) then
		        forceT[1] *= -1 ;
		    else if (lastFT[1] > 0 and forceT[1] < 0) then
		        forceT[1] *= -1 ;
		    )
		if (lastFT[2] != 0 ) then
		    (
		    if (lastFT[2] < 0 and forceT[2] > 0) then
		        forceT[2] *= -1 ;
		    else if (lastFT[2] > 0 and forceT[2] < 0) then
		        forceT[2] *= -1 ;
		    )
		if (lastFT[3] != 0 ) then
		    (
		    if (lastFT[3] < 0 and forceT[3] > 0) then
		        forceT[3] *= -1 ;
		    else if (lastFT[3] > 0 and forceT[3] < 0) then
		        forceT[3] *= -1 ;
		    )


			-- Now store all this data for this frame.
			--
		animate on
			(
			slave.forceT1 = forceT[1];
			slave.forceT2 = forceT[2];
			slave.forceT3 = forceT[3];
			slave.forceR1 = forceR[1];
			slave.forceR2 = forceR[2];
			slave.forceR3 = forceR[3];

			k = addNewKey slave.forceT1.controller t;
			k.inTangentType = k.outTangentType = #linear;
			k = addNewKey slave.forceT2.controller t;
			k.inTangentType = k.outTangentType = #linear;
			k = addNewKey slave.forceT3.controller t;
			k.inTangentType = k.outTangentType = #linear;
			k = addNewKey slave.forceR1.controller t;
			k.inTangentType = k.outTangentType = #linear;
			k = addNewKey slave.forceR2.controller t;
			k.inTangentType = k.outTangentType = #linear;
			k = addNewKey slave.forceR3.controller t;
			k.inTangentType = k.outTangentType = #linear;
			)


			-- Now store values for next time around
		coordsys world ( oldWR = quatToEuler ctrl.rotation order:1; );
		t1 = t2;
	    lastFT = forceT ;
	    lastFR = forceR;

		)	-- end of  main loop



	delete mX;			-- erase measuring helpers.
	delete mY;
	delete mZ;

    sliderTime = ot;		-- go back to original time now.


	setArrowCursor();
    enableSceneRedraw();

	select ctrl;
)



-- --------------------------------------------------------------------------

/*
 * sL_animateLag() -
 */
fn sL_animateLag =
(
    objs = getCurrentSelection();

	if (objs.count <= 0) then
		(
		format "-- ERROR: You must select the objects to be auto-animated with lag!\n";
		return();
		)


		-- animate each object
    for obj in objs do
    	(
	    ctrlName = sL_getCtrlName obj.name;
	    ctrl = execute("$"+ctrlName+";");

			-- First see if our object has a valid rig setup...
			-- and if it is a SIMPLE or SUPER type rig....
			--
		try (
			if (EmptyModifier != undefined) then
				attrStr = ctrl.Attribute_Holder.strX;
			else
				attrStr = ctrl.strX;
			)
		catch
			(
			attrStr = undefined;
			)

		try (
			if (EmptyModifier != undefined) then
				attrFD = ctrl.Attribute_Holder.frameDelay;
			else
				attrFD = ctrl.frameDelay;
			)
		catch
			(
			attrFD = undefined;
			)

			-- If we have found valid attrs, do the appropriate lag.
			--
		if (attrStr != undefined) then
			sL_doLag ctrl;		-- call real worker function
		else if (sL_bakeOnLag == true and attrFD != undefined) then
			sL_doBakeSimpleLag ctrl;
		)

)



-- --------------------------------------------------------------------------


/*
 * sL_doEraseLag() - Erases lag frames on object
 */
fn sL_doEraseLag ctrl all =
(

    if (ctrl == undefined) then
        return();

	ctrlName = sL_getCtrlName ctrl.name;
	ctrl = execute("$"+ctrlName+";");

    if (ctrl == undefined) then
        return();
	
    slaveName = sL_getSlaveName ctrl.name;
    slave = execute("$"+slaveName+";");

    if (slave == undefined) then
    	(
		format "-- ERROR: You must select a valid Lag CTRL object, with a similarly named LagSLAVE object parented underneath!\n";
		return();
		)


		-- First see if our object has a valid rig setup...
		-- and if it is a SIMPLE or SUPER type rig....
		--
	try (
		if (EmptyModifier != undefined) then
			attrStr = ctrl.Attribute_Holder.strX;
		else
			attrStr = ctrl.strX;
		)
	catch
		(
		attrStr = undefined;
		)

	try (
		if (EmptyModifier != undefined) then
			attrFD = ctrl.Attribute_Holder.frameDelay;
		else
			attrFD = ctrl.frameDelay;
		)
	catch
		(
		attrFD = undefined;
		)

		-- If we have found valid attrs, do the appropriate erase lag.
		--
	if (attrStr != undefined) then
		(
		st = animationRange.start;
		et = animationRange.end;

		iv = (interval st et);
		if (all == false) then
			(
			selectKeys slave.forceT1.controller iv;
			deleteKeys slave.forceT1.controller #selection;
			selectKeys slave.forceT2.controller iv;
			deleteKeys slave.forceT2.controller #selection;
			selectKeys slave.forceT3.controller iv;
			deleteKeys slave.forceT3.controller #selection;
			selectKeys slave.forceR1.controller iv;
			deleteKeys slave.forceR1.controller #selection;
			selectKeys slave.forceR2.controller iv;
			deleteKeys slave.forceR2.controller #selection;
			selectKeys slave.forceR3.controller iv;
			deleteKeys slave.forceR3.controller #selection;
			
			k = addNewKey slave.forceR1.controller st;
			k.value = 0 ;
			k = addNewKey slave.forceR2.controller st;
			k.value = 0 ;
			k = addNewKey slave.forceR3.controller st;
			k.value = 0 ;
			k = addNewKey slave.forceR1.controller et;
			k.value = 0 ;
			k = addNewKey slave.forceR2.controller et;
			k.value = 0 ;
			k = addNewKey slave.forceR3.controller et;
			k.value = 0 ;
			k = addNewKey slave.forceT1.controller st;
			k.value = 0 ;
			k = addNewKey slave.forceT2.controller st;
			k.value = 0 ;
			k = addNewKey slave.forceT3.controller st;
			k.value = 0 ;
			k = addNewKey slave.forceT1.controller et;
			k.value = 0 ;
			k = addNewKey slave.forceT2.controller et;
			k.value = 0 ;
			k = addNewKey slave.forceT3.controller et;
			k.value = 0 ;
			)
		else
			(
			selectKeys slave.forceT1.controller iv;
			deleteKeys slave.forceT1.controller #allKeys;
			selectKeys slave.forceT2.controller iv;
			deleteKeys slave.forceT2.controller #allKeys;
			selectKeys slave.forceT3.controller iv;
			deleteKeys slave.forceT3.controller #allKeys;
			selectKeys slave.forceR1.controller iv;
			deleteKeys slave.forceR1.controller #allKeys;
			selectKeys slave.forceR2.controller iv;
			deleteKeys slave.forceR2.controller #allKeys;
			selectKeys slave.forceR3.controller iv;
			deleteKeys slave.forceR3.controller #allKeys;
		
			slave.forceT1 = 0.0 ;
			slave.forceT2 = 0.0 ;
			slave.forceT3 = 0.0 ;
			slave.forceR1 = 0.0 ;
			slave.forceR2 = 0.0 ;
			slave.forceR3 = 0.0 ;
			)

		)
	else if (attrFD != undefined) then
		(
			-- Don't do if it is not a super slave BAKED...
		if (classOf (slave.rotation.controller) == rotation_script) then
			(
			return();
			)

		st = animationRange.start;
		et = animationRange.end;

		if (all == false) then
			(
				-- Blow away all old keys on this time range
				--
			iv = (interval st et);
			selectKeys slave.rotation.x_rotation.controller iv;
			deleteKeys slave.rotation.x_rotation.controller #selection;
			selectKeys slave.rotation.y_rotation.controller iv;
			deleteKeys slave.rotation.y_rotation.controller #selection;
			selectKeys slave.rotation.z_rotation.controller iv;
			deleteKeys slave.rotation.z_rotation.controller #selection;
			selectKeys slave.position.controller iv;
			deleteKeys slave.position.controller #selection;

			k = addNewKey slave.rotation.x_rotation.controller st;
			k.value = 0;
			k = addNewKey slave.rotation.y_rotation.controller st;
			k.value = 0;
			k = addNewKey slave.rotation.z_rotation.controller st;
			k.value = 0;
			k = addNewKey slave.rotation.x_rotation.controller et;
			k.value = 0;
			k = addNewKey slave.rotation.y_rotation.controller et;
			k.value = 0;
			k = addNewKey slave.rotation.z_rotation.controller et;
			k.value = 0;
			coordsys parent
				(
				slave.position = [0,0,0];
				)
			)
		else
			(
			selectKeys slave.rotation.x_rotation.controller ;
			deleteKeys slave.rotation.x_rotation.controller #allKeys;
			selectKeys slave.rotation.y_rotation.controller ;
			deleteKeys slave.rotation.y_rotation.controller #allKeys;
			selectKeys slave.rotation.z_rotation.controller ;
			deleteKeys slave.rotation.z_rotation.controller #allKeys;
			selectKeys slave.position.controller ;
			deleteKeys slave.position.controller #allKeys;

			coordsys parent
				(
				slave.rotation = (eulerangles 0 0 0);
				slave.position = [0,0,0];
				)
			)


		)


)



-- --------------------------------------------------------------------------

/*
 * sL_eraseLag() -
 */
fn sL_eraseLag all =
(
    objs = getCurrentSelection();

	if (objs.count <= 0) then
		(
		format "-- ERROR: You must select the objects to have lag erased on!\n";
		return();
		)


		-- delete each related slave
    for obj in objs do
    	(
		sL_doEraseLag obj all;		-- call real worker function
		)

)



-- --------------------------------------------------------------------------

/*
 * sL_selCtrls() -
 */
fn sL_selCtrls =
(
	objs = getCurrentSelection();

	clearSelection();		-- start with nada

	for obj in objs do
	   	(
		cName = sL_getCtrlName obj.name;
		c = execute("$'"+cName+"';");
		if (c != undefined) then
			selectMore c;

		)
)



-- --------------------------------------------------------------------------

/*
 * sL_selSlaves() -
 */
fn sL_selSlaves =
(
	objs = getCurrentSelection();

	clearSelection();		-- start with nada

	for obj in objs do
	   	(
		sName = sL_getSlaveName obj.name;
		s = execute("$'"+sName+"';");
		if (s != undefined) then
			selectMore s;

		)
)


-- --------------------------------------------------------------------------

-- --------------------------------------------------------------------------
-- 		U.I. and Rollout Stuff
-- --------------------------------------------------------------------------

-- --------------------------------------------------------------------------

rollout sL_mainRoll "Lag"
(

	group "Animation"
		(
	    button btn_doLag "Calculate (Bake) Lag Data" tooltip:"Processes the needed data for lag on selected nodes." width:214 align:#center;
		checkbox cb_bakeOnLag "Bake SIMPLE Lag nodes, even if Realtime" checked:true tooltip:"Any selected SIMPLE Lag nodes will be converted and animated to baking, PERMANENTLY losing realtime ability." offset:[2,0];

	    button btn_selCtrl "Select CTRLs" tooltip:"Selects CTRL objects based on currently selected Slave Auto objects." width:107 align:#center across:2;
	    button btn_selSlave "Select AUTO Slaves" tooltip:"Selects Auto Slave objects based on currently selected CTRLs." width:107 align:#center;
	    button btn_doErase "Erase Lag For Current Time Range" tooltip:"Erases lag on selected nodes only in the current time range.." width:214 align:#center;
	    button btn_doEraseAll "Erase Lag" tooltip:"Erases ALL lag keys on selected nodes." width:214 align:#center;
		)


	on btn_doLag pressed do
		(
		undo "Animate Lag" on
			(
			sL_animateLag();
			)
		)

	on btn_doErase pressed do
		(
		undo "Erase Lag" on
			(
			sL_eraseLag false;
			)
		)

	on btn_doEraseAll pressed do
		(
		undo "Erase Lag" on
			(
			sL_eraseLag true;
			)
		)

	on btn_selCtrl pressed do
		(
		undo "Select CTRLs" on
			(
			sL_selCtrls();
			)
		)

	on btn_selSlave pressed do
		(
		undo "Select AUTO Slaves" on
			(
			sL_selSlaves();
			)
		)

	on cb_bakeOnLag changed val do
		(
		sL_bakeOnLag = val;
		)

)


-- --------------------------------------------------------------------------


rollout sL_rigRoll "Setup"
(

	group "Rigging"
		(
	    button btn_doRigChain "Rig as Chain (SUPER then SIMPLE)" tooltip:"Rigs selected nodes as a chain, so first node does SUPER and the rest do  SIMPLE lagging." width:214 align:#center;

	    checkbutton divider3 height:2 width:214 checked:true enabled:false;

		checkbox cb_bakeSimple "Rig SIMPLE Lag for Baking, Not Realtime" checked:true tooltip:"Sets any simple nodes to bake their and rotation not do a realtime script based lag." offset:[2,0];
	    button btn_doRigSuper "Rig Selected Nodes for SUPER Lag" tooltip:"Rigs selected nodes to do SUPER based lagging." width:214 align:#center;
	    button btn_doRigSimple "Rig Selected Nodes for SIMPLE Lag" tooltip:"Rigs selected nodes to do SIMPLE-Delay based lagging." width:214 align:#center;
	    )

	on btn_doRigSuper pressed do
		(
		undo "Rig/Setup Lag" on
			(
			sL_rig 1;
			)
		)

	on btn_doRigSimple pressed do
		(
		undo "Rig/Setup Lag" on
			(
			sL_rig 2;
			)
		)

	on btn_doRigChain pressed do
		(
		undo "Rig/Setup Lag" on
			(
			sL_rig 0;
			)
		)


	on cb_bakeSimple changed val do
		(
		sL_bakeSimple = val;
		)

)

-- --------------------------------------------------------------------------


rollout sL_aboutRoll "About"
(
	label abt_1 "superLag" align:#center
	label abt_2 "Version: " align:#center
	label abt_3 "By" align:#center
	label abt_4 "Michael B. Comet" align:#center
	label abt_5 "comet@comet-cartoons.com" align:#center
	hyperLink abt_6 "http://www.comet-cartoons.com/" address:"http://www.comet-cartoons.com/toons/" color:(color 0 0 200) hoverColor:(color 255 128 0)  align:#center;

	label abt_c1 " " align:#center
	label abt_c2 "superLag Copyright 2003 Michael B. Comet" align:#center
	label abt_c3 "All Rights Reserved " align:#center
	label abt_c4 " " align:#center

	on sL_aboutRoll open do
	(
	abt_2.text = ("Version: "+sL_version);
	)

)

-- --------------------------------------------------------------------------

rolloutSuperLagFloater = newRolloutFloater ("superLag - "+sL_version) 260 230;
addRollout sL_mainRoll rolloutSuperLagFloater;
addRollout sL_rigRoll rolloutSuperLagFloater rolledup:true;
addRollout sL_aboutRoll rolloutSuperLagFloater rolledUp:true;



)	-- end of superLag.mcr


-- --------------------------------------------------------------------------

