/*
 * trackViewFlatten.ms - Michael B. Comet - comet@comet-cartoons.com
 *									  http://www.comet-cartoons.com/
 *  Copyright 2002 Michael B. Comet  All Rights Reserved
 *
 *  Special Thanks to Adam Felt at Discreet for the base sample code.
 *
 *  Version 1.00 - July 09, 2002 - Initial Rev.   - Michael B. Comet
 *
 *  INSTRUCTIONS:
 *		1. Run this script or drop into 3dsmax\stdplugs\stdscripts\ so that
 *			it will run automatically.
 *		2. Open up a TrackView...
 *		3. From the Utilities menu inside of trackview, choose "Track View Utilities..."
 *		4. Choose "trackViewFlatten - Comet Cartoons" from the list and hit OK.
 *		5. The list is now entirely flattened.  If you wish to see XYZ labels, choose
 *				that. If you wish to see Modifier labels, choose that checkbox.
 *
 *
 */

global string tVF_version = "1.00";

global filterTV

plugin TrackViewUtility trackViewFlatten
	name:"trackViewFlatten - Comet Cartoons"
	category:"Comet Cartoons"
--	category:"Scripted TV Utilities"
	classID:#(0x7dd557a7, 0x60df8282)
(
	rollout extraFilters "trackViewFlatten" width:90 height:178
	(
		label lbl_title "trackViewFlatten" pos:[4,0];

		checkbutton filterOFF "Disable" pos:[4,18] width:65 height:18;

		GroupBox valueGroup "Show" pos:[4,40] width:67 height:50
			checkbox filterXYZ "XYZ" pos:[10,55] width:55 height:15;
			checkbox filterMods "MODs" pos:[10,72] width:55 height:15;

		button btnClose "Close" pos:[4,97] width:65 height:18;
		label lbl_version "Version" pos:[20,117];
		label lbl_about1 "Michael Comet" pos:[4,132];
		label lbl_about2 "Comet Cartoons" pos:[4,147];

	--	local tv

		on filterOFF changed state do
		(
			filterTV.updateList()
		)
		on filterXYZ changed val do
		(
			filterTV.updateList()
		)
		on filterMods changed val do
		(
			filterTV.updateList()
		)

		on btnClose pressed do
		(
			filterOFF.checked = true;
			filterXYZ.checked =false;
			filterMods.checked =false;
		    filterTV.updateList();	 -- do final refresh

			cui.floatDialogBar extraFilters;
			cui.unregisterDialogBar extraFilters;
			destroyDialog extraFilters;
		)

	)

	on create do
	(
	)

	on Init val do
	(
--		print val
		filterTV = val
--		print filterTV
		createDialog extraFilters parent:(val.ui.hwnd)
		cui.registerDialogBar extraFilters parent:(val.ui.hwnd)
		cui.dockDialogBar extraFilters #right

		extraFilters.lbl_version.text = "Version - "+tVF_version;
		filterTV.updateList();	 -- do initial refresh
	)

	on FilterAnim anim client subNum do
	(

-- 		format "--DEBUG anim=% client=% subNum=% classAnim=% supAnim=% classClient=% supClient=%\n" anim client subNum (classOf anim) (superClassOf anim) (classOf client) (superClassOf client);


		if extraFilters.filterOFF.checked == true do		-- If totally disabled, then show all.
		    return #add;

		if extraFilters.filterXYZ.checked == false do
			(
			if classof anim == Position_XYZ do
				(
				return #skip
				)
			if classof anim == Euler_XYZ do
				(
				return #skip
				)
			if classof anim == ScaleXYZ do
				(
				return #skip
				)
			)

		if extraFilters.filterMods.checked == false do
			(

			if superClassOf anim == Modifier do
				(
				return #skip
				)
			)

			-- Top Root Level stuff
 		if client == (Root_Node) then
			(
			return #skip;
			)
			-- TM's....
		if superclassof anim == Matrix3Controller do
			(
			return #skip
			)
			-- Objects...
		if superClassOf anim == GeometryClass do
			(
			return #skip
			)
		if superClassOf anim == shape do
			(
			return #skip
			)
		if superClassOf anim == light do
			(
			return #skip
			)
		if superClassOf anim == camera do
			(
			return #skip
			)
		if superClassOf anim == helper do
			(
			return #skip
			)
		if superClassOf anim == SpacewarpObject do
			(
			return #skip
			)
/*
		if classOf client == NodeObject then
			(
			return #skip;
			)
*/
			-- Custom Attribute Label...
		if superClassOf anim == CustAttrib do
			(
			return #skip
			)

		return #add

	) -- end of on FilterAnim

)
